package com.edunetcracker.simulator.model.element.router;

import com.edunetcracker.simulator.model.DTO.SocketMessageDTO;
import com.edunetcracker.simulator.model.context.NEContext;
import com.edunetcracker.simulator.model.dataUnit.IDataUnit;
import com.edunetcracker.simulator.model.dataUnit.ethernet.Ethernet;
import com.edunetcracker.simulator.model.dataUnit.ethernet.arp.ARP;
import com.edunetcracker.simulator.model.dataUnit.ip.IP;
import com.edunetcracker.simulator.model.dataUnit.DataUnit;
import com.edunetcracker.simulator.model.element.NetworkElement;
import com.edunetcracker.simulator.model.element.router.addressResolution.ARPTable;
import com.edunetcracker.simulator.model.port.Port;
import com.edunetcracker.simulator.model.port.RouterPort;
import com.edunetcracker.simulator.model.element.router.routing.RouteSource;
import com.edunetcracker.simulator.model.element.router.routing.routingTable.RoutingTable;
import com.edunetcracker.simulator.model.element.router.routing.routingTableEntry.RoutingTableEntry;
import com.edunetcracker.simulator.service.WSService;
import com.edunetcracker.simulator.service.context.ContextService;
import com.edunetcracker.simulator.service.routingService.IpService;
import com.edunetcracker.simulator.service.routingService.RoutingTableService;
import com.edunetcracker.simulator.service.status.SequenceStatus;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


import java.util.*;
import javax.persistence.*;


@Setter
@Getter
@Entity
public class Router extends NetworkElement {
    private static Logger logger = LoggerFactory.getLogger(Router.class);



    @JsonProperty
    @OneToMany(mappedBy = "router",
               cascade = CascadeType.ALL,
               fetch = FetchType.EAGER)
    @Fetch(FetchMode.SELECT)
    @NotFound(action = NotFoundAction.IGNORE)
    private List<RouterPort> ports;


    @JsonProperty
    @OneToOne(cascade=CascadeType.ALL,
              fetch = FetchType.EAGER)
    @JoinColumn(name="routing_table_id",
                referencedColumnName="id")
    @Fetch(FetchMode.SELECT)
    @NotFound(action = NotFoundAction.IGNORE)
    private RoutingTable routingTable;

    @Transient
    private ARPTable arpTable;

    @Transient
    private  ContextService contextService;


    public Router() {
        super();
        this.typeName = "router";
        routingTable = new RoutingTable(this);
        arpTable = new ARPTable();
        ports = new ArrayList<>();
        contextService = ContextService.getInstance();
    }

    public void updateCurrentPosition(Router router) {
        this.setX(router.getX());
        this.setY(router.getY());
        this.setNameNE(router.getNameNE());
    }

    @Override
    public void start () {
        ports.stream()
                .filter(port -> null != port.getConnection())
                .forEach(port -> port.setActive(true));
        initializeRunningRoutes();
        super.start();
    }

    @Override
    protected void send(SocketMessageDTO message){
        WSService.getInstance().send(message);
    }

    @Override
    public SequenceStatus copyRefs(NetworkElement another) {
        if (!(another instanceof Router)) {
            SequenceStatus.PARAMETER_TYPE_INCONSISTENCY.logError("Router");
            return SequenceStatus.PARAMETER_TYPE_INCONSISTENCY;
        }
        super.copyRefs(another);
        Router anotherRouter = (Router)another;
        this.ports = anotherRouter.ports;
        this.routingTable = anotherRouter.routingTable;
        return SequenceStatus.OK;
    }

    @Override
    public SequenceStatus copyAutogeneratedValues(NetworkElement another) {
        if (!(another instanceof Router)) {
            SequenceStatus.PARAMETER_TYPE_INCONSISTENCY.logError("Router");
            return SequenceStatus.PARAMETER_TYPE_INCONSISTENCY;
        }
        super.copyAutogeneratedValues(another);
        return SequenceStatus.OK;
    }


    @Override
    protected void processContexts() {
        logger.trace("Processing contexts");
        Iterator contextsIterator = this.contexts.iterator();

        while (contextsIterator.hasNext()) {
            NEContext context = (NEContext) contextsIterator.next();
            List<IDataUnit> dataUnits = context.performAction();
            if (null != dataUnits) {
                processDataUnits(dataUnits);
            }
            if (!context.isAlive()) {
                contextsIterator.remove();
            }
        }

        arpTable.onTick(); //ToDo(Wisp): Move this to somewhere else. Probably to a brand new "processProtocols()" method.
    }

    @Override
    protected void processInputTraffic() {
        Object[] nonemptyPortsArr = ports.stream()
                                   .filter(Port::hasInput)
                                   .toArray();
        LinkedList nonemptyPorts = new LinkedList(Arrays.asList(nonemptyPortsArr));
        ListIterator<RouterPort> portIter = nonemptyPorts.listIterator();

        int processedDUnitsNumber = 0;
        while (processedDUnitsNumber < inputProcessingRate) {
            if (!portIter.hasNext()) {
                if (!nonemptyPorts.isEmpty()) {
                    portIter = nonemptyPorts.listIterator();
                } else { break; }
            }
            RouterPort curPort = portIter.next();

            if (processPortInput(curPort)) { ++processedDUnitsNumber; }
            else {
                portIter.remove();
            }
        }
        evaluateLoading(processedDUnitsNumber);
    }

    private boolean processPortInput (RouterPort port) {
        DataUnit dataUnit = port.getIn().poll();
        if (null == dataUnit) {
            return false;
        }
        processDataUnit(dataUnit, port);

        return true;
    }

    private void processDataUnits (List<IDataUnit> dataUnits) {
        for (IDataUnit dataUnit : dataUnits) {
            if (null != dataUnit) {
                processDataUnit(dataUnit);
            }
        }
    }

    private void processDataUnit (IDataUnit dataUnit) {
        processDataUnit(dataUnit, null);
    }

    private void processDataUnit (IDataUnit dataUnit, RouterPort inputPort) {
        logger.info("Router ID{}: Processing dataUnit", getIdNE());

        if (null == dataUnit) { throw new NullPointerException("Null dataUnit"); }

        DataUnit.Type dataUnitType = dataUnit.getType();

        switch (dataUnitType) {
            case Ethernet: {
                processEthernet((Ethernet)dataUnit, inputPort);
            } break;
            case IP: {
                processIp((IP)dataUnit);
            }
        }
    }


    private void processEthernet(Ethernet frame, RouterPort inputPort) {
        logger.info("Router ID{}: Processing Ethernet.", getIdNE());

        if (null == inputPort) {
            throw new NullPointerException("Null inputPort.");
        }
        if (!Ethernet.BROADCAST_MAC.equals(frame.getDestinationMAC()) &&
            !inputPort.getMac().equals(frame.getDestinationMAC()))    {
            return;
        }
        if (!frame.getEncapsulated().isPresent() &&
             frame.getExtraData() == null) {
            return;
        }

        switch (frame.getEncapsulatedType()) {
            case None: {
                logger.info("The Ethernet contained no-type data.");
                return;
            }
            case ARP: {
                processARP(frame, inputPort);
                return;
            }
            default: {
                processDataUnit(frame.getEncapsulated().get(), inputPort);
            }
        }
    }


    private void processARP(Ethernet arpEthernet, RouterPort inputPort) {
        logger.info("Router ID{}: Processing ARP.", getIdNE());

        if (null == arpEthernet) { throw new NullPointerException("Null arpEthernet"); }
        if (null == inputPort)   { throw new NullPointerException("Null inputPort"); }
        if (!arpEthernet.getEncapsulated().isPresent()) { return; }

        ARP arp = (ARP)arpEthernet.getEncapsulated().get();
        ARP.TypeARP typeARP = arp.getTypeARP();
        Long sourceMAC = arpEthernet.getSourceMAC();
        Integer questionedIP = arp.getQuestionedIp();
        Integer sourceIP = arp.getSourceIp();

        if (null == typeARP   || null == sourceMAC    ||
            null == sourceIP  || null == questionedIP) {
            throw new NullPointerException("Incomplete ARP frame.");
        }

        switch (typeARP) {
            case REQUEST: {
                logger.info("This is ARP-request. SourceIp: {}", IpService.stringFromInt(sourceIP));
                logger.info("Requested port has IP {}. This one has {}.", IpService.stringFromInt(questionedIP), IpService.stringFromInt(inputPort.getIp()));

                arpTable.addEntry(sourceIP, sourceMAC);

                if (!inputPort.getIp().equals(questionedIP)) {
                    return;
                }

                arp.setTypeARP(ARP.TypeARP.REPLY);
                arpEthernet.setSourceMAC(inputPort.getMac());
                arpEthernet.setDestinationMAC(sourceMAC);
                inputPort.push(arpEthernet);
                return;
            }
            case REPLY: {
                logger.info("This is ARP-reply.");
                arpTable.addEntry(questionedIP, sourceMAC);
                return;
            }
        }
    }

    private void processIp (IP packet) {
        logger.info("Router ID{}: Processing IP.", getIdNE());
        RoutingTableEntry routingTableEntry = routingTable.getEntryByIp(packet.getDestinationIp());
        Optional<RouterPort> port = findLeadingPort(packet.getDestinationIp());

        if (null == port) {
            logger.info("Destination {} is unreachable.", IpService.stringFromInt(packet.getDestinationIp()));
            return;
        }
        if (port.isPresent()) {
            logger.info("Destination \"{}\" is reachable through port N{} w/ ip \"{}\"", IpService.stringFromInt(packet.getDestinationIp()), port.get().getOrder(), IpService.stringFromInt(port.get().getIp()));
            if (null == packet.getSourceIp()) {
                packet.setSourceIp(port.get().getIp());
            }

            Integer nextHop = routingTableEntry.getNextHop();
            if (null == nextHop) {
                nextHop = packet.getDestinationIp();
            }

            Ethernet ethernet = null;
            Long nextHopMAC = arpTable.getMAC(nextHop);

            if (null != nextHopMAC) {
                ethernet = wrapToEthernet(packet, port.get().getMac(), arpTable.getMAC(nextHop));
            } else {
                logger.info("No corresponding ARP-table entry. Sending ARP-request.");
                ARP arp = new ARP(port.get().getIp(), nextHop, ARP.TypeARP.REQUEST);
                ethernet = wrapToEthernet(arp, port.get().getMac(), 0L);
            }
            port.get().push(ethernet);

            NEContext context = contextService.fromTransitionalIp(packet);

            if (null != context) {
                contexts.add(context);
            }
        } else {
            logger.info("The router is a destination \"{}\"",
                         IpService.stringFromInt(packet.getDestinationIp()));
            NEContext context = contextService.fromAcceptedIp(sessionId, packet);
            if (null != context) {
                Optional<NEContext> savedContext = contexts.stream()
                                                    .filter(nextContext -> nextContext.equals(context))
                                                    .findFirst();
                if (savedContext.isPresent()) {
                    logger.info("Context id{} is present.", savedContext.get().getId());
                    savedContext.get().performInput(packet);
                } else {
                    logger.info("Context id{} is new to this router.", context.getId());
                    contexts.add(context);
                }
            }
        }
    }

    /**
     *
     * @param dataUnit DataUnit to be wrapped
     * @param sourceMAC MAC address of a sending port
     * @param destinationMAC MAC address of a destination port. Can be broadcast.
     * @return MAC address of nextHop port, if corresponding entry is present in an ARP table,
     *         or nullPtr, if is not.
     */
    private Ethernet wrapToEthernet(DataUnit dataUnit, Long sourceMAC, Long destinationMAC) {
        if (null == destinationMAC ||
            null == sourceMAC        ) {
            return null;
        }
        Ethernet ethernet = new Ethernet();
        ethernet.setDestinationMAC(destinationMAC);
        ethernet.setSourceMAC(sourceMAC);
        ethernet.setEncapsulatedType(dataUnit.getType());
        ethernet.encapsulate(dataUnit);
        return ethernet;
    }


    @Override
    protected void processCommands() {

    }

    public void initializeRunningRoutes() {
        if (null == routingTable || null == ports) {
            SequenceStatus.FAILED_INITIALIZATION.logError("Router", "routingTable or ports");
            throw new NullPointerException();
        }
        routingTable.loadSavedRoutesToRunning();
        for (RouterPort port : ports) {
            RoutingTableEntry[] dcroutes = RoutingTableService.constructDirectConnection(port);
            if (null != dcroutes) {
                routingTable.addRoute(dcroutes[0]);
                routingTable.addRoute(dcroutes[1]);
            }
        }
    }


    /**
     * Searches for a port leading to the given destination IP.
     * @param ip
     * @return 1) Optional with null,       if port w/ destination IP is owned by the router
     *         2) Optional with instance,   if the appropriate port was found
     *         3) Null,                     if the router can't route to the given IP.
     */
    public Optional<RouterPort> findLeadingPort (Integer ip) {
        logger.trace("Router ID{} seeks for port leading to IP{} ", getIdNE(), IpService.stringFromInt(ip));

        Integer subnetOfInterest = null;

        RoutingTableEntry entry = routingTable.getEntryByIp(ip);
        if (null == entry) {
            return null;
        }
        if (RouteSource.LOCAL_PORT.equals(entry.getRouteSource())) {
            logger.trace("This is the entry of a local port.");
            return Optional.empty();
        }
        if (RouteSource.CONNECTED_SUBNETWORK.equals(entry.getRouteSource())) {
            logger.trace("This is the entry of a connected subnetwork {}. Looking for a local port of this subnet:", IpService.stringFromInt(entry.getIp()));
            subnetOfInterest = entry.getIp();
        } else {
            logger.trace("Looking for a port in a subnet of {}.", IpService.stringFromInt(entry.getNextHop()));
            subnetOfInterest = entry.getNextHop();
        }
        for (RouterPort port : ports) {
            logger.trace("Port N{}. IP: {}, mask {}", port.getOrder(), IpService.stringFromInt(port.getIp()), IpService.stringFromInt(port.getMask()));
            if (null != port.getIp() &&
                IpService.isInSubnet(subnetOfInterest, port.getIp(), port.getMask())) {
                logger.trace("Yes! {} and {} are in one subnet!", IpService.stringFromInt(subnetOfInterest), IpService.stringFromInt(port.getIp()));
                return Optional.of(port);
            }
        }
        return null;
    }

    /**
     * Returns port with number given. (Each port has it's unique number in a NetworkElement.)
     * @param portNumber
     * @return
     */
    public RouterPort getPort(int portNumber) {
        for (RouterPort port : ports) {
            if (portNumber == port.getOrder()) {
                return port;
            }
        }
        return null;
    }


    public void sendToFront (SocketMessageDTO socketMessageDTO) {

    }
}
